// BS"D
// An InDesign script by Ariel Walden, (c) www.Id-Extras.com, 2014
// Based on an idea by Adam Marshall, http://tinyurl.com/6xnhzcl
// Number formats based on 'Chicago Manual of Style', 15th ed., Ch. 9:22

const theScriptName = "Format long numbers";
app.doScript (main, undefined, undefined, UndoModes.ENTIRE_SCRIPT, theScriptName);

function main(){
	var s = app.selection[0];
	if (!s || !s.hasOwnProperty("findGrep") || s instanceof InsertionPoint){
		alert("Please select something that is susceptible to a Grep search, such as text or a text frame, and try again.");
		exit();
	}

	var w, decimalDropdown, delimiterDropdown, countryDropdown, ignore4;
	w = new Window("dialog", theScriptName);
	with (w){
		alignChildren = "right";
		with (add("group")){
			orientation = "row";
			add("statictext", undefined, "Delimiter style:");
			with (countryDropdown = add("dropdownlist", undefined, ["US & British", "Canadian", "Continental Europe"])){
				selection = 0;
				preferredSize.width = 150;
			}
		}
		with (add("group")){
			orientation = "row";
			add("statictext", undefined, "Decimal point character:");
			with (decimalDropdown = add("dropdownlist", undefined, ["Period", "Comma"])){
				selection = 0;
				preferredSize.width = 150;
				enabled = false;
			}
		}
		with (add("group")){
			orientation = "row";
			add("statictext", undefined, "Group separator:");
			with (delimiterDropdown = add("dropdownlist", undefined, ["Comma", "Thin Space"])){
				selection = 0;
				preferredSize.width = 150;
				enabled = false;
			}
		}
		with(ignore4 = add("checkbox", undefined, "Ignore 4 digit numbers")){
			alignment = "center";
		}
		with (add("group")){
			orientation = "row";
			add("button", undefined, "OK");
			add("button", undefined, "Cancel");
		}
	}
	countryDropdown.onChange = function(){
		switch (countryDropdown.selection.index){
			case 0:
				decimalDropdown.selection = 0;
				delimiterDropdown.selection = 0;
			break;
			case 1:
				decimalDropdown.selection = 0;
				delimiterDropdown.selection = 1;
			break;
			case 2:
				decimalDropdown.selection = 1;
				delimiterDropdown.selection = 1;
			break;
		}
	}
					
	if (w.show() == 2){
		exit();
	}

	var D, E = "", G, X;	
	D = decimalDropdown.selection.index ? "," : ".";
	G = delimiterDropdown.selection.index ? "\u2009" : ",";
	D == "." && E = "\\";
	X = "\\d+"+E+D+"{0,1}\\d+";
	app.findGrepPreferences = null;
	app.findGrepPreferences.findWhat = X;
	var myFinds = s.findGrep(), f, n, t, d;
	while (f = myFinds.pop()){
		n = f.contents.toString().split('.');
		// Add commas to thousands
		if (!ignore4.value || (n[0] && n[0].length > 4)){
			t = n[0].split('').reverse().join('').match(/.{1,3}/g).join(G).split('').reverse().join('');
		}
		// Add commas to decimals if there are any.
		if (!ignore4.value || (n[1] && n[1].length > 4)){
			n[1] && (d = n[1].match(/.{1,3}/g).join(G), t += D + d);
		}
		t && f.contents = t;
	}
}